<%@ LANGUAGE=JSCRIPT %>

<%


// Contemplate Reporter (reporter.asp) version 1.0.3
// Copyright 1999-2003 Type A Multimedia Network (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


	Server.ScriptTimeout = 300; // this is important for the reporter, since processing a data file can take several minutes
	
// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");


//  define some useful subroutines

	function get_file_simple($file) {
		$text = "";

		$file = absolute_path($file, "filesystem");
		FSO = Server.CreateObject("Scripting.FileSystemObject");
		$file_exists = FSO.FileExists($file);
		if (! $file_exists) {
			return "Error: Can't find file " + $file;
		} else {
			$myfile = FSO.OpenTextFile($file, 1, false, 0);
			$text = $myfile.ReadAll();
			$myfile.Close();
		}
		FSO = "";

		// conform all line breaks to avoid cross-platform issues
		$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
		$text = $text.replace(/\n/g, "\r"); // change Unix to Mac

		// remove extra line breaks at the end of the file so all the languages perform splits in the same way
		$text = $text.replace(/(.*[^\r])\r*$/, "$1");
		
		return $text;	
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? Request.QueryString($setting_no_spaces) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}

	function absolute_path($path, $method) { // convert a reference to a file within our site to an absolute URL
		if ($script_location) { // if this hasn't been set yet, just return the original value

			if ($method == "filesystem") {
			
				$path = Server.MapPath($path);
	
			} else {
			
				$thisserver = String(Request.ServerVariables("HTTP_HOST"));
				$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				$re = new RegExp("\/([^=]*\/)" + $URL_rewriting_flag + "\/", "i");
				if ($re.test($request)) { $thispath = RegExp.$1; }
				
				// pass along the authentication information if present
				$auth_info = String(Request.ServerVariables("HTTP_AUTHORIZATION"));
				if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
					$auth_info = $auth_info.substr(5);
					$login = Base64Decode($auth_info);
					$login += "@";
				} else {
					$login = "";
				}
				
				$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath);
			
			}
		
		}
		return $path;
	}

	function random_color() {
		$colors = new Array("00","33","66","99","CC","FF");
		$r = $colors[Math.floor(Math.random() * 5)]; //rand(5) instead of rand(6) keeps them from getting too light to read
		$g = $colors[Math.floor(Math.random() * 5)];
		$b = $colors[Math.floor(Math.random() * 5)];
		$color = "#" + $r + $g + $b;
		return $color;	
	}
	
	function month_display($month) { // converts 2003-05 to May 2003
		$month_year = $month.split("-");
		$month_display = $months[parseFloat($month_year[1]) - 1];
		$year_display = $month_year[0];
		return $month_display + " " + $year_display;
	}
	
	
	function ucfirst($str) { // capitalizes the first character of $str; this is a substitute for PHP's ucfirst() built-in function
		return $str.replace(/.{1}/, $str.charAt(0).toUpperCase());
	}
	
	function regex_quote($source) { // this is a substitute for PHP's preg_quote() built-in function
		// PHP escapes: . \\ + * ? [ ^ ] $ ( ) { } = ! < > | :
		$source = $source.replace(/\\/g, "\\\\");
		$source = $source.replace(/\./g, "\\.");
		$source = $source.replace(/\+/g, "\\+");
		$source = $source.replace(/\*/g, "\\*");
		$source = $source.replace(/\?/g, "\\?");
		$source = $source.replace(/\[/g, "\\[");
		$source = $source.replace(/\^/g, "\\^");
		$source = $source.replace(/\]/g, "\\]");
		$source = $source.replace(/\$/g, "\\$");
		$source = $source.replace(/\(/g, "\\(");
		$source = $source.replace(/\)/g, "\\)");
		$source = $source.replace(/\{/g, "\\{");
		$source = $source.replace(/\}/g, "\\}");
		$source = $source.replace(/\//g, "\\/");
		$source = $source.replace(/\:/g, "\\:");
		return $source;
	}


//  set up some primary variables 
	
	$URL_rewriting_flag = "assembled"; // we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	// figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	// this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	// apparent, rather than the actual, location of assembler.asp
	// this will also prevent problems if Windows calculates relative paths from the server root
	$request = (String(Request.ServerVariables("OS")).indexOf("Win") != -1) ? String(Request.ServerVariables("SCRIPT_NAME")) : ( (String(Request.ServerVariables("REQUEST_URI")).indexOf("?") != -1) ? String(Request.ServerVariables("REQUEST_URI")).substr(0, String(Request.ServerVariables("REQUEST_URI")).indexOf("?")) : String(Request.ServerVariables("REQUEST_URI")) ) ;
	$script_location = String(Request.ServerVariables("PATH_TRANSLATED"));
	$script_location = $script_location.replace(/\\/g, "/");
	$re = new RegExp("(.*\/)" + $URL_rewriting_flag + "\/", "i");
	if ($re.test($script_location)) {
		$script_location = RegExp.$1 + "contemplate/";
	} else {
		$re = new RegExp("(.*\/)[^\/]+", "");
		if ($re.test($script_location)) { $script_location = RegExp.$1; }
	}
	
	$month = (Request.QueryString("month") != $undefined) ? String(Request.QueryString("month")) : "" ;
	$section = (Request.QueryString("section") != $undefined) ? Request.QueryString("section") : "" ;
	$clear = (Request.Form("clear") != $undefined) ? Request.Form("clear") : "" ;		
	$inspector_key = (Request.QueryString("inspector_key") != $undefined) ? String(Request.QueryString("inspector_key")) : "" ;		
	$inspector_value = (Request.QueryString("inspector_value") != $undefined) ? String(Request.QueryString("inspector_value")) : "" ;		
	$back_label = (Request.QueryString("back_label") != $undefined) ? Request.QueryString("back_label") : "" ;
	$realtime = (Request.QueryString("realtime") != $undefined) ? Request.QueryString("realtime") : "" ;
	
	$output = "";
	$button = "";
	$settings_used = "";
	$hits_greatest = 1;
	$blank_marker = "--";
	$graph_width = 200;
	$my_host = new String(Request.ServerVariables("HTTP_HOST"));
	$my_domain = ($my_host.substr(0,4) == "www.") ? $my_host.substr(3, $my_host.length) : $my_host ;
	
	$show_performance = 0;
	$performance_times = "";
	$JScript_date = new Date();
	$last_performance_time = $JScript_date.getSeconds();
	$total_performance_time = 0;

	$data_directory = "../../contemplate/reporter/data/";
	$data_file = $data_directory + $month + ".txt";
	$error_file = $data_directory + $month + "-errors.txt";

	$columns = new Array("dates", "IP_addresses", "hosts", "pages", "user_agents", "referrers");
	$columns_errors = new Array("dates", "IP_addresses", "hosts", "pages", "user_agents", "referrers", "message");

	$sections = new Array("dates", "IP_addresses", "hosts", "pages", "user_agents", "referrers", "countries");
	$sections_display = new Array("dates", "IP addresses", "hosts", "pages", "user agents", "referrers", "countries");
	for ($i=0; $i<$sections.length; $i++) {
		eval("$" + $sections[$i] + " = new Array()");
	}	
	
	$months = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

	$HTTP_error_codes = new Array();
		$HTTP_error_codes["404"] = "File not found";
		$HTTP_error_codes["403"] = "Forbidden";
		$HTTP_error_codes["401"] = "Not authorized";

	$country_codes = new Array();
		$country_codes["com"] = "US Commercial";
		$country_codes["edu"] = "US Educational";
		$country_codes["org"] = "US Organization";
		$country_codes["net"] = "US Network";
		$country_codes["gov"] = "US Government";
		$country_codes["mil"] = "US Military";
		$country_codes["ac"] = "Ascension Island";
		$country_codes["ad"] = "Andorra";
		$country_codes["ae"] = "United Arab Emirates";
		$country_codes["af"] = "Afghanistan";
		$country_codes["ag"] = "Antigua and Barbuda";
		$country_codes["ai"] = "Anguilla";
		$country_codes["al"] = "Albania";
		$country_codes["am"] = "Armenia";
		$country_codes["an"] = "Netherland Antilles";
		$country_codes["ao"] = "Angola";
		$country_codes["aq"] = "Antarctica";
		$country_codes["as"] = "American Samoa";
		$country_codes["at"] = "Austria";
		$country_codes["au"] = "Australia";
		$country_codes["aw"] = "Aruba";
		$country_codes["az"] = "Azerbaijan";
		$country_codes["ba"] = "Bosnia and Herzegowina";
		$country_codes["bb"] = "Barbados";
		$country_codes["bd"] = "Bangladesh";
		$country_codes["be"] = "Belgium";
		$country_codes["bf"] = "Burkina Faso";
		$country_codes["bg"] = "Bulgaria";
		$country_codes["bh"] = "Bahrain";
		$country_codes["bi"] = "Burundi";
		$country_codes["bj"] = "Benin";
		$country_codes["bj"] = "Bermuda";
		$country_codes["bo"] = "Bolivia";
		$country_codes["br"] = "Brazil";
		$country_codes["bs"] = "Bahamas";
		$country_codes["bt"] = "Bhutan";
		$country_codes["bv"] = "Bouvet Island";
		$country_codes["bw"] = "Botswana";
		$country_codes["by"] = "Belarus";
		$country_codes["bz"] = "Belize";
		$country_codes["ca"] = "Canada";
		$country_codes["cc"] = "Cocos (Keeling) Islands";
		$country_codes["cd"] = "Zaire";
		$country_codes["cf"] = "Central African Republic";
		$country_codes["cg"] = "Congo";
		$country_codes["ch"] = "Switzerland";
		$country_codes["ci"] = "Cte d'Ivoire";
		$country_codes["ck"] = "Cook Islands";
		$country_codes["cl"] = "Chile";
		$country_codes["cm"] = "Cameroon";
		$country_codes["cn"] = "China";
		$country_codes["co"] = "Columbia";
		$country_codes["cr"] = "Costa Rica";
		$country_codes["cs"] = "Czechoslovakia";
		$country_codes["cu"] = "Cuba";
		$country_codes["cv"] = "Cape Verde";
		$country_codes["cx"] = "Christmas Island";
		$country_codes["cy"] = "Cyprus";
		$country_codes["cz"] = "Czech Republic";
		$country_codes["de"] = "Germany";
		$country_codes["dj"] = "Djibouti";
		$country_codes["dk"] = "Denmark";
		$country_codes["dm"] = "Dominica";
		$country_codes["do"] = "Dominican Republic";
		$country_codes["dz"] = "Algeria";
		$country_codes["ec"] = "Ecuador";
		$country_codes["ee"] = "Estonia";
		$country_codes["eg"] = "Egypt";
		$country_codes["eh"] = "Western Sahara";
		$country_codes["er"] = "Eritrea";
		$country_codes["es"] = "Spain";
		$country_codes["et"] = "Ethiopia";
		$country_codes["fi"] = "Finland";
		$country_codes["fj"] = "Fiji";
		$country_codes["fk"] = "Falkland Islands";
		$country_codes["fm"] = "Micronesia";
		$country_codes["fr"] = "France";
		$country_codes["fx"] = "France, Metropolitan";
		$country_codes["ga"] = "Gabon";
		$country_codes["gb"] = "Grenada";
		$country_codes["ge"] = "Georgia";
		$country_codes["gf"] = "French Guiana";
		$country_codes["gg"] = "Guernsey";
		$country_codes["gh"] = "Ghana";
		$country_codes["gi"] = "Gibraltar";
		$country_codes["gl"] = "Greenland";
		$country_codes["gm"] = "Gambia";
		$country_codes["gn"] = "Guinea";
		$country_codes["gp"] = "Guadelope";
		$country_codes["gq"] = "Equatorial Guinea";
		$country_codes["gr"] = "Greece";
		$country_codes["gs"] = "S. Georgia/S. Sandwich Is.";
		$country_codes["gt"] = "Guatemala";
		$country_codes["gu"] = "Guam";
		$country_codes["gw"] = "Guinea-Bissau";
		$country_codes["gy"] = "Guyana";
		$country_codes["hk"] = "Hong Kong";
		$country_codes["hn"] = "Honduras";
		$country_codes["hr"] = "Croatia";
		$country_codes["ht"] = "Haiti";
		$country_codes["hu"] = "Hungary";
		$country_codes["id"] = "Indonesia";
		$country_codes["ie"] = "Ireland";
		$country_codes["il"] = "Israel";
		$country_codes["im"] = "Isle of Man";
		$country_codes["in"] = "India";
		$country_codes["io"] = "British Indian Ocean Territory";
		$country_codes["iq"] = "Iraq";
		$country_codes["ir"] = "Iran";
		$country_codes["is"] = "Iceland";
		$country_codes["it"] = "Italy";
		$country_codes["je"] = "Jersey";
		$country_codes["jm"] = "Jamaica";
		$country_codes["jo"] = "Jordan";
		$country_codes["jp"] = "Japan";
		$country_codes["ke"] = "Kenya";
		$country_codes["kg"] = "Kyrgystan";
		$country_codes["kh"] = "Cambodia";
		$country_codes["ki"] = "Kiribati";
		$country_codes["km"] = "Comoros";
		$country_codes["kn"] = "Saint Kitts and Nevis";
		$country_codes["kp"] = "Korea, People's Republic of";
		$country_codes["kr"] = "Korea, Republic of";
		$country_codes["kw"] = "Kuwait";
		$country_codes["ky"] = "Cayman Islands";
		$country_codes["kz"] = "Kazakhstan";
		$country_codes["la"] = "Lao Democratic Republic";
		$country_codes["lb"] = "Lebanon";
		$country_codes["li"] = "Liechtenstein";
		$country_codes["lk"] = "Sri Lanka";
		$country_codes["lr"] = "Liberia";
		$country_codes["ls"] = "Lethoso";
		$country_codes["lt"] = "Lithuania";
		$country_codes["lu"] = "Luxembourg";
		$country_codes["lv"] = "Latvia";
		$country_codes["ly"] = "Libyan Arab Jamahiriya";
		$country_codes["ma"] = "Morocco";
		$country_codes["mc"] = "Monaco";
		$country_codes["md"] = "Moldova";
		$country_codes["mg"] = "Madagascar";
		$country_codes["mh"] = "Marshall Islands";
		$country_codes["mk"] = "Macedonia";
		$country_codes["ml"] = "Mali";
		$country_codes["mm"] = "Myanmar";
		$country_codes["mn"] = "Mongolia";
		$country_codes["mo"] = "Macau";
		$country_codes["mp"] = "Northern Mariana Islands";
		$country_codes["mq"] = "Martinique";
		$country_codes["ms"] = "Montserrat";
		$country_codes["mt"] = "Malta";
		$country_codes["mu"] = "Mauritius";
		$country_codes["mv"] = "Maldives";
		$country_codes["mw"] = "Malawi";
		$country_codes["mx"] = "Mexico";
		$country_codes["my"] = "Malaysia";
		$country_codes["mz"] = "Mozambique";
		$country_codes["na"] = "Namibia";
		$country_codes["nc"] = "New Caledonia";
		$country_codes["ne"] = "Niger";
		$country_codes["nf"] = "Norfolk Island";
		$country_codes["ng"] = "Nigeria";
		$country_codes["ni"] = "Nicaragua";
		$country_codes["nl"] = "The Netherlands";
		$country_codes["no"] = "Norway";
		$country_codes["np"] = "Nepal";
		$country_codes["nr"] = "Nauru";
		$country_codes["nt"] = "Neutral Zone";
		$country_codes["nu"] = "Niue";
		$country_codes["nz"] = "New Zealand";
		$country_codes["om"] = "Oman";
		$country_codes["pa"] = "Panama";
		$country_codes["pe"] = "Peru";
		$country_codes["pf"] = "French Polynesia";
		$country_codes["pg"] = "Papua New Guinea";
		$country_codes["ph"] = "Philippines";
		$country_codes["pk"] = "Pakistan";
		$country_codes["pl"] = "Poland";
		$country_codes["pm"] = "St. Pierre and Miquelon";
		$country_codes["pn"] = "Pitcairn";
		$country_codes["pr"] = "Puerto Rico";
		$country_codes["pt"] = "Portugal";
		$country_codes["pw"] = "Palau";
		$country_codes["py"] = "Paraguay";
		$country_codes["qa"] = "Qatar";
		$country_codes["re"] = "Reunion";
		$country_codes["ro"] = "Romania";
		$country_codes["ru"] = "Russia";
		$country_codes["rw"] = "Rwanda";
		$country_codes["sa"] = "Saudi Arabia";
		$country_codes["sb"] = "Solomon Islands";
		$country_codes["sd"] = "Sudan";
		$country_codes["se"] = "Sweden";
		$country_codes["sg"] = "Singapore";
		$country_codes["sh"] = "Saint Helena";
		$country_codes["si"] = "Slovenia";
		$country_codes["sj"] = "Svalbard/Jan Mayen Islands";
		$country_codes["sk"] = "Slovakia";
		$country_codes["sl"] = "Sierra Leone";
		$country_codes["sm"] = "San Marino";
		$country_codes["sn"] = "Senegal";
		$country_codes["so"] = "Somalia";
		$country_codes["sr"] = "Surinam";
		$country_codes["st"] = "Sao Tome and Principe";
		$country_codes["su"] = "USSR";
		$country_codes["sv"] = "El Salvador";
		$country_codes["sy"] = "Syrian Arab Republic";
		$country_codes["sz"] = "Swaziland";
		$country_codes["tc"] = "The Turks & Caicos Islands";
		$country_codes["td"] = "Chad";
		$country_codes["tf"] = "French Southern Territories";
		$country_codes["tg"] = "Togo";
		$country_codes["th"] = "Thailand";
		$country_codes["tj"] = "Tajikistan";
		$country_codes["tk"] = "Tokelau";
		$country_codes["tm"] = "Turkmenistan";
		$country_codes["tn"] = "Tunesia";
		$country_codes["to"] = "Tonga";
		$country_codes["tp"] = "East Timor";
		$country_codes["tr"] = "Turkey";
		$country_codes["tt"] = "Trinidad and Tobago";
		$country_codes["tv"] = "Tuvalu";
		$country_codes["tw"] = "Taiwan";
		$country_codes["tz"] = "Tanzania";
		$country_codes["ua"] = "Ukraine";
		$country_codes["ug"] = "Uganda";
		$country_codes["uk"] = "United Kingdom";
		$country_codes["um"] = "U.S. Minor Outlying Islands";
		$country_codes["us"] = "United States";
		$country_codes["uy"] = "Uruguay";
		$country_codes["uz"] = "Uzbekistan";
		$country_codes["va"] = "Vatican City State";
		$country_codes["vc"] = "Saint Vincent & Grenadines";
		$country_codes["ve"] = "Venezuela";
		$country_codes["vg"] = "British Virgin Islands";
		$country_codes["vi"] = "U.S. Virgin Islands";
		$country_codes["vn"] = "Vietnam";
		$country_codes["vu"] = "Vanuatu";
		$country_codes["wf"] = "Wallis and Futuna Islands";
		$country_codes["ws"] = "Samoa";
		$country_codes["ye"] = "Yemen";
		$country_codes["yt"] = "Mayotte";
		$country_codes["yu"] = "Yugoslavia";
		$country_codes["zm"] = "Zambia";
		$country_codes["zr"] = "Zaire";
		$country_codes["zw"] = "Zimbabwe";
	
		country_codes_reversed = new Array();
		for (country_code in $country_codes) {
			country_codes_reversed[$country_codes[country_code]] = country_code;
		}
		
	
// read in a preferences (.ini) file if one exists, and show which preferences may be overridden from the URL string

	$preferences = get_file_simple("../preferences.ini");
	if ($preferences) {
		//$URL_rewriting_flag = get_setting($preferences, "URL rewriting flag", 1, 1);
		$top_n = get_setting($preferences, "top n", 1, 1);
		$graph_image = get_setting($preferences, "graph image", 1, 1);
		$graph_color = get_setting($preferences, "graph color", 1, 1);
		$update_interval = get_setting($preferences, "real-time update interval", 1, 1);
		$maximum_column_width = get_setting($preferences, "column width", 1, 1);
		$show_inspector_rollover = get_setting($preferences, "inspector rollover", 1, 1);
		$one_big_page = get_setting($preferences, "one big page", 1, 1);
	} else {
		//$URL_rewriting_flag = "";
		$top_n = "";
		$graph_color = "";
		$graph_image = "";
		$update_interval = "";
		$maximum_column_width = "";
		$show_inspector_rollover = "";
		$one_big_page = "";
	}
	

// do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	//if ($URL_rewriting_flag == "") { $URL_rewriting_flag = "assembled"; }

	if ($top_n === "") { $top_n = 5; }

	if ($graph_color === "") { $graph_color = "0000FF"; } // Flash does not use # to denote a hex value
	$graph_color = $graph_color.replace("#", ""); // Flash doesn't use # to denote a hex value

	if ($graph_image === "") { $graph_image = "../graphics/logo.jpg"; }
	$graph_image = "../" + $graph_image; // make the path relative to the Flash file, which is in a subdirectory of the Contemplate directory
	$graph_image = $graph_image.replace("../../", "%252E%252E%252F%252E%252E%252F"); // double-encode the up delimiter to prevent Mac IE from decoding and then rewriting it
	
	if ($update_interval === "") { $update_interval = 30; }

	if ($maximum_column_width === "") { $maximum_column_width = 64; }

	// this is eye candy that probably slows down page rendering somewhat
	if ($show_inspector_rollover === "") { $show_inspector_rollover = 1; }
	$show_inspector_rollover = parseFloat($show_inspector_rollover);

	// this shows the full data for each section on the same page as the top $top_n
	if ($one_big_page === "") { $one_big_page = 0; }
	$one_big_page = parseFloat($one_big_page);
	

//  if requested, delete the error log

	if ($clear) {
		FSO = Server.CreateObject("Scripting.FileSystemObject");
		if (FSO.FileExists($error_file)) {
			FSO.DeleteFile($error_file);
		}
		FSO = "";
	}


// if called from the real-time Flash viewer, provide some data for that

	if ($realtime) {
	
		// reinitialize $data_file to use the current month rather than looking in the URL string for a month
		$year = String($JScript_date.getYear());
		$month = String($JScript_date.getMonth() + 1);
		if ($month < 10) { $month = "0" + $month; }
		$data_file = $year + "-" + $month + ".txt";
		$data_file_text = $data_file;
		$data_file = $data_directory + $data_file;
	
		// open the log file
		$text = get_file_simple($data_file);
	
		// create an array from the lines in the file
		$text = $text.split("\r");		
	
		// loop through the array and count the number of lines that contain the appropriate number of columns	
		$hits_total = 0;
		for ($j=0; $j < $text.length; $j++) {
			$next = $text[$j].split("\t");
			if ($next.length == $columns.length) {
				$hits_total++;
			}
		}
		
		// grab just the last ten lines to pass back to the Flash viewer
		if ($text.length > 10) {
			$tail = $text.slice(-10);
		}
				
		// add the country code to each line	
		for ($j=0; $j < $tail.length; $j++) {
			$next = $tail[$j].split("\t");
			$host = $next[2]; // note that this is a hard-coded reference to the host that will break if we change the format of the data file; we could use the extract/clean up/reassemble routine used in the inspector_key section below to avoid that
			$re = /\.([^\.\d]+)$/; $matches = $host.match($re);
			if ($matches) { $tail[$j] += "\t" + $country_codes[$matches[1]]; } else { $tail[$j] += "\t" + $blank_marker; }
		}
				
		// finally, print the results out for the Flash viewer to read
		$tail = Server.urlencode($tail.join("\n"));
		Response.write("hits=" + $hits_total + "&data_file=" + $data_file_text + "&tail=" + $tail);	
		
		Response.end();
	
	}


//  set up the HTML page

	Response.Write("<html>\r");
	Response.Write("<head>\r");
	Response.Write("<title>Contemplate(tm) Web Content Manager</title>\r");
	Response.Write("<link rel=stylesheet href=../stylesheet.css type=text/css>\r");
	Response.Write("<script language=JavaScript> login = 0; </script>\r");
	Response.Write("<script language=JavaScript src=../login/login.js></script>\r");
	Response.Write("<script language=JavaScript> if (!login) { location = '../../index.html'; } </script>\r");
	Response.Write("</head>\r");
	Response.Write("<body bgcolor=#FFFFFF>\r");
	Response.Write("<p class=title>Contemplate</p>\r");
	Response.Write("<p class=body><a href=../index.html>Utilities menu</a> &gt; Reporter</p>\r");
	Response.Write("<div class=body>\r");
	Response.Flush();
	
	if ($show_performance) {
		$JScript_date = new Date();
		$this_performance_time = $JScript_date.getSeconds();
		$performance_times += "&nbsp;&nbsp;script and page setup - " + ($this_performance_time - $last_performance_time) + " seconds<br>\r";
		$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
		$last_performance_time = $this_performance_time;
	}


// if an inspect key is provided, focus on a cross-section of the month's report

	if ($inspector_key) {


	// clean up the input a bit
		
		for ($i=0; $i<$sections.length; $i++) {
			// it's nice for users to pass in the section name as the inspect key, but the section index is more useful to us
			if ($inspector_key == $sections[$i]) { $inspector_key_index = $i; }
		}
		if ($inspector_key_index == 6) {
			// countries is really just a part of the host value
			$inspector_key_index = 2;
		}
		
			
	// read the data file for the current month and save the lines that match the inspect value
	
		$text = get_file_simple($data_file);

		$hits_total = 0;
		$text = $text.split("\r")
		for ($j=0; $j<$text.length; $j++) {
			$text[$j] = $text[$j].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
			$next = $text[$j].split("\t");
			if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have

				// dates have to start with value, country codes have to end with value, all others have to equal value
				$match_end = ($inspector_key == "dates") ? ".*" : "" ;
				$match_start = ($inspector_key == "countries") ? ".*" : "" ;
				$re = new RegExp("^" + $match_start + regex_quote(String($inspector_value)) + $match_end + "$", "");
				if ($re.test($next[$inspector_key_index])) {

					// extract the values out of the log entry
					for ($i=0; $i < $columns.length; $i++) {
						eval("$this_" + $columns[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
					}
				
					// clean up some of the values
					// - convert TLD to country code
					$re = /\.([^\.]+)$/;
					if ($re.test($this_hosts)) { $this_countries = $country_codes[RegExp.$1]; } else { $this_countries = $blank_marker; }
						
					// then add each value to the appropriate array
					eval("$line_" + $hits_total + " = new Array()");
					for ($i=0; $i < $sections.length; $i++) {
						eval("$line_" + $hits_total + "[$i] = $this_" + $sections[$i]);
					}
			
					$hits_total++;
				
				}
			}
		}
		

	// print the matching lines in a table

		$output = $output + "<p class=heading><a name=top>Traffic for " + month_display($month) + "</a></p>\r";
		
		$inspector_key_singular = $inspector_key.substr(0, $inspector_key.length - 1);
		if ($inspector_key_singular == "IP addresse") { $inspector_key_singular = $inspector_key_singular.substr(0, $inspector_key_singular.length - 1); }
		if ($inspector_key_singular == "countrie") { $inspector_key_singular = "country"; }
		$output = $output + "<b>Where " + $inspector_key_singular + " contains " + $inspector_value + "</b><br>\r";
		$output = $output + "<b>Total hits: " + $hits_total + "</b><p>\r\r";
		
		$output = $output + "&lt;&ndash; <a href=JavaScript:history.back()>" + $back_label + "</a><p>\r\r";

		$output = $output + "<table cellpadding=2 cellspacing=0 border=0>\r\r";
		
		$output = $output + "<tr bgcolor=#CCCCCC>\r";
		for ($i=0; $i < $sections.length; $i++) {
			$output = $output + "<td class=subheading>" + ucfirst($sections[$i]) + "</td>\r";
		}
		$output = $output + "</tr>\r\r";
	
		for ($j=0; $j < $hits_total; $j++) {	
			eval("$this_line_array = $line_" + $j);
			$output = $output + "<tr valign=top>\r";
			for ($i=0; $i < $sections.length; $i++) {
				$output = $output + "<td class=body>\r";
				$output = $output + $this_line_array[$i] + "\r";
				$output = $output + "</td>\r";
			}
			$output = $output + "</tr>\r\r";
		}
		
		$output = $output + "</table><p>\r\r";
	
		$output = $output + "&lt;&ndash; <a href=JavaScript:history.back()>" + $back_label + "</a><p>\r\r";


//  if a month is specified, display that month's report

	} else if ($month) {
	
	
	// read the data file
	
		$text = get_file_simple($data_file);
		
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;load data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}


	// split the data into lines and columns and create associative arrays

		$hits_total = 0;
		$text = $text.split("\r")
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;split data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}
		for ($j=0; $j<$text.length; $j++) {
			$text[$j] = $text[$j].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
			$next = $text[$j].split("\t");
			if ($next.length == $columns.length) { // make sure the line has all the elements we're expecting it to have

				// extract the values out of the log entry
				for ($i=0; $i < $columns.length; $i++) {
					eval("$this_" + $columns[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
				}
			
				// clean up some of the values
				// - ignore times to group hits by day
				$this_dates = $this_dates.substr(0, $this_dates.indexOf(" "));
				// - convert TLD to country code
				$re = /\.([^\.]+)$/;
				if ($re.test($this_hosts)) { $this_countries = $country_codes[RegExp.$1]; } else { $this_countries = $blank_marker; }
				// - filter self-referrers
				if (($this_referrers == $my_domain)||($this_referrers.length < 3)) { $this_referrers = $blank_marker; }
					
				// then add each value to the appropriate array
				for ($i=0; $i < $sections.length; $i++) {
					eval("$isset = ($" + $sections[$i] + "[$this_" + $sections[$i] + "] + '' != 'undefined')"); // e.g. if ($dates["2003-05"]) != 'undefined') {
					if ($isset) {
						eval("$" + $sections[$i] + "[$this_" + $sections[$i] + "]++");
						eval("$this_hits = $" + $sections[$i] + "[$this_" + $sections[$i] + "]");
						if ($this_hits > $hits_greatest) { $hits_greatest = $this_hits; }
					} else {
						eval("$" + $sections[$i] + "[$this_" + $sections[$i] + "] = 1");
					}
				}
		
				$hits_total++;
				
			}
		}
		
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;process data file - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}

		
	// print the reports in a table
		
		$output += "<p class=heading><a name=top>Traffic for " + month_display($month) + "</a></p>\r\r";
		
		$output += "<p class=subheading>Total hits: " + $hits_total + "</p><br>\r\r";
		
		$output += "<p class=body>\r";
		$output += "<a href=reporter.asp>Months</a> &gt; \r";
		if (($section)&&(!$one_big_page)) {
			$output += "<a href=reporter.asp?month=" + $month + ">Top " + $top_n + "'s</a> &gt; \r";
		} else {
			$output += "Top " + $top_n + "'s &gt; \r";
		}
		$output += "<font color=#0000FF>All</font> ";
		for ($i=0; $i < $sections.length; $i++) {
			$link = ($one_big_page) ? ("#" + $sections[$i]) : ("reporter.asp?month=" + $month + "&section=" + $sections[$i]);
			if ($section == $sections[$i]) {
				$output += ucfirst($sections_display[$i]) + ", ";
			} else {
				$output += "<a href=" + $link + ">" + ucfirst($sections_display[$i]) + "</a>, ";
			}
		}
		
		if ($section == "errors_HTTP") {
			$output += "HTTP errors, ";
		} else {
			if ($one_big_page) {
				$output += "<a href=#errors_HTTP>HTTP errors</a>, ";
			} else {
				$output += "<a href=reporter.asp?month=" + $month + "&section=errors_HTTP>HTTP errors</a>, ";
			}
		}
		if ($section == "errors_assembler") {
			$output += "Assembler errors<p>";
		} else {
			if ($one_big_page) {
				$output += "<a href=#errors_assembler>Assembler errors</a>\r";
			} else {
				$output += "<a href=reporter.asp?month=" + $month + "&section=errors_assembler>Assembler errors</a>\r";
			}
		}
		$output += "</p>\r\r";
		
		$inspector_button_ID = 0;
			
		$output += "<table cellpadding=2 cellspacing=0 border=0>\r\r";
		
		if ($show_performance) {
			$JScript_date = new Date();
			$this_performance_time = $JScript_date.getSeconds();
			$performance_times += "&nbsp;&nbsp;set up section links - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
			$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
			$last_performance_time = $this_performance_time;
		}

		$passes = 2;
		for ($h=0; $h < $passes; $h++) { // print all the tables twice, the first time showing just the top $top_n ...
		
			// ... but if we're splitting the sections up, skip the first or second pass
			if (!$one_big_page) {
				if (!$section) {
					$passes = 1; // only do the first part
				} else {
					$h = 1; // only do the second part
				}
			}
			
			for ($i=0; $i < $sections.length; $i++) {
				
				// skip unless we're displaying this section, or no section is specified
				
				if ((!$section) || ($section == $sections[$i])) {
			
					if ($h == 0) {
						$label = "Top " + $top_n + " " + $sections_display[$i];
						$button_link = ($one_big_page) ? ("#" + $sections[$i]) : ("reporter.asp?month=" + $month + "&section=" + $sections[$i]) ;
						$button = "<a href=" + $button_link + ">All " + $sections_display[$i] + "</a>";
						$space_after = 18;
					} else {
						$label = "<a name='" + $sections[$i] + "'>All " + $sections_display[$i] + "</a>";
						if ($one_big_page) { $button = "<a href=#top>Top</a>"; }
						$space_after = 36;
					}
	
					$output += "<tr><td colspan=6 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br>" + $label + "</td></tr>\r\r";
					
					// sort the full dates list by key and everything else by value
					if (($sections[$i] == "dates")&&($h == 1)) {
						eval("$this_section_array = $" + $sections[$i]);
						$this_section_array = $this_section_array.sort();
						$this_section_keys = new Array();
						//$this_section_values = new Array();
						for ($key in $this_section_array) {
							$this_section_keys.push($key);
							//$this_section_values.push($this_section_array[$key]);
						}
					} else {
						// JScript can't sort associative arrays, so we have to flatten this into a regular array with the value first, sort that, then split it up again
						eval("$this_section_array = $" + $sections[$i]);
						$this_section_array_flattened = new Array();
						for ($key in $this_section_array) {
							$value = $this_section_array[$key];
							$this_section_array_flattened.push($value + " :: " + $key);
						}
						
						function sort_descending (a,b) { return ( (parseFloat(a)>parseFloat(b)) ? -1 : ( (parseFloat(a)<parseFloat(b)) ? 1 : 0 ) ) }
						$this_section_array_flattened.sort(sort_descending);					
						
						$this_section_keys = new Array();
						//$this_section_values = new Array();
						for ($j=0; $j<$this_section_array_flattened.length; $j++) {
							$this_pair = $this_section_array_flattened[$j].split(" :: ");
							$this_section_keys.push($this_pair[1]);
							//$this_section_values.push($this_pair[0]);
						}
					}
					
					// for the partial list, crop to the first $top_n values
					if ($h == 0) {
						$this_section_keys.splice($top_n, $this_section_keys.length);
						//$this_section_values.splice($top_n, $this_section_values.length);
					}
						
					if ($show_performance) {
						$JScript_date = new Date();
						$this_performance_time = $JScript_date.getSeconds();
						$performance_times += "&nbsp;&nbsp;sort and crop " + $sections[$i] + " data - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
						$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
						$last_performance_time = $this_performance_time;
					}

					// okay, now we can finally print the rows
					$this_limit = ($this_section_keys.length < $top_n) ? $this_section_keys.length : $top_n ;
					$keys_count = ($h > 0) ? $this_section_keys.length : $this_limit ;
					
					for ($j=0; $j < $keys_count; $j++) {
						
						$key = $this_section_keys[$j];
						//$value = $this_section_values[$j];
						eval("$value = $" + $sections[$i] + "[$key]");
																		
						$inspector_key = $sections[$i];
						$inspector_value = $key;
						
						// untranslate the country code for the inspect script
						if ($sections[$i] == "countries") {
							$inspector_value = "." + eval("country_codes_reversed[\"" + $inspector_value + "\"]");
						}
						
						// do some basic URL-encoding on the inspect value
						$inspector_key = Server.urlencode($inspector_key);
						$inspector_value = Server.urlencode($inspector_value);
												
						// limit the item display length to a predetermined number of characters
						$key_complete = $key;
						$key = ($key.length > $maximum_column_width) ? ($key.substr(0, $maximum_column_width) + "...") : $key ;
						
						// make the referrer items into a link
						if ($sections[$i] == "referrers") {
							$key = ($key != $blank_marker) ? ("<a href=" + $key_complete + " target='_new'>" + $key + "</a>") : $key ;
						}
						
						// provide a link for seeing all the fields for a particular item
						$back_label = ($section) ? ("All " + $section) : ("Top " + $top_n + "%27s") ;
						$back_label = $back_label.replace("_"," ");
						$back_label = $back_label.replace(" ", "%20");
						if ($show_inspector_rollover) {
							$inspector_link = ($key != $blank_marker) ? ("<a href='reporter.asp?month=" + $month + "&inspector_key=" + $inspector_key + "&inspector_value=" + $inspector_value + "&back_label=" + $back_label + "'><img src=../graphics/inspector_0.gif onmouseover='document.images.inspector_" + $inspector_button_ID + ".src=\"../graphics/inspector_1.gif\"' onmouseout='document.images.inspector_" + $inspector_button_ID + ".src=\"../graphics/inspector_0.gif\"' width=12 height=12 border=0 name=inspector_" + $inspector_button_ID + " alt='Inspect'></a>") : "&nbsp;" ;
							$inspector_button_ID++;
						} else {
							$inspector_link = ($key != $blank_marker) ? ("<a href='reporter.asp?month=" + $month + "&inspector_key=" + $inspector_key + "&inspector_value=" + $inspector_value + "&back_label=" + $back_label + "'><img src=../graphics/inspector_0.gif width=12 height=12 border=0 alt='Inspect'></a>") : "&nbsp;" ;
						}
						
						$output += "<tr valign=top><td class=body>\r";
						$output += $inspector_link + "&nbsp;";
						$output += "</td>\n<td class=body>\r";
						$output += $key;
						$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td class=body>\r";
						$output += $value;
						$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td width=" + $graph_width + ">\r";
						$output += "<font color=" + random_color() + "><img src=../graphics/spacer.gif height=4 width=" + (($value / $hits_greatest) * $graph_width) + " border=1></font>\r";
						$output += "</td></tr>\r\r";
						
					}
						
					// more/top buttons after listings
					$output += "<tr><td colspan=6 class=body>" + $button + "</td></tr>\r\r";
					
					// space between rows
					if (!$section) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=" + $space_after + " width=1></td></tr>\r\r"; }
					
					if ($show_performance) {
						$JScript_date = new Date();
						$this_performance_time = $JScript_date.getSeconds();
						$performance_times += "&nbsp;&nbsp;print " + $sections[$i] + " data - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
						$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
						$last_performance_time = $this_performance_time;
					}

				}
				
			}
			
			
			// space between sections
			if ($h == 0) {
				if ($one_big_page) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=36 width=1></td></tr>\r\r"; }
			}				
			
		}
		
		
// look for an error file and print those, too
		
		// skip if this is the menu and we're splitting the sections up
		if (($one_big_page)||($section)) {
			for ($h=0; $h<2; $h++) {
				
				$error_type = ($h == 0) ? "HTTP" : "assembler";
				
				// skip unless we're displaying this section, or no section is specified
				if ((!$section)||($section == "errors_" + $error_type)) {
					
					$error_list = "";

					$output += "<tr><td colspan=6 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br><a name='errors_" + $error_type + "'>All " + $error_type + " errors</a></td></tr>\r\r";

					$text = get_file_simple($error_file);
					
					if ($text.indexOf("Error: ") != 0) {
						$text = $text.split("\r");
						for ($j=0; $j<$text.length; $j++) {
							$text[$j] = $text[$j].replace(/\\/g, "\\\\"); // a backslash at the end of a line causes problems, so remove those
							$next = $text[$j].split("\t");
							if ($next.length == $columns_errors.length) { // make sure the line has all the elements we're expecting it to have
							
								// extract the values out of the log entry
								for ($i=0; $i < $columns_errors.length; $i++) {
									eval("$this_" + $columns_errors[$i] + " = ($next[$i] != '') ? $next[$i] : $blank_marker ");
								}
				
								// clean up some of the values
								$this_pages = ($this_pages.length > ($maximum_column_width + 24)) ? ($this_pages.substr(0, ($maximum_column_width + 24)) + "...") : $this_pages ; // limit the page display length
								
								$re = /\d\d\d/;
								if (($error_type == "assembler")&&(!$re.test($this_message.substr(0, 3)))&&($this_message.substr(0, 3) != "Unk")) {
									// show assembler errors first...
									$this_message = $this_message.replace(",", "<br>");
									$error_list += "<tr><td colspan=6 class=body>" + $this_dates + "<br>" + $this_pages + "<br>" + $this_message + "<hr></td></tr>\r";
								} else if (($error_type == "HTTP")&&($re.test($this_message.substr(0, 3)))||($this_message.substr(0, 3) == "Unk")) {
									// ...then HTTP errors
									$this_message = $this_message.replace(/[^\d]/g,""); // strip it down to just the error code
									$this_message = ($HTTP_error_codes[$this_message]) ? ($this_message + ": " + $HTTP_error_codes[$this_message]) : "Unknown error" ;
									$error_list += "<tr><td colspan=6 class=body>" + $this_dates + "<br>" + $this_pages + "<br>" + $this_message + "<hr></td></tr>\r";
								}
								
							}
						}
						$output += $error_list;
					}
					
					if ($error_list) {
						// provide a button for clearing the error log
						$output += "<tr><td colspan=6 class=body>\r";
						$output += "<form name=clear method=post><input type=hidden name=clear value=1><input type=hidden name=month value=" + $month + "></form>\r";
						$output += "<script language=JavaScript>\n function clearErrors() {\r";
						$output += "if (confirm('Are you sure you want to clear the error log for this month?')) { document.clear.submit(); }\r }\r";
						$output += "</script>\r";
						$output += "<a href=JavaScript:clearErrors()>Clear error log</a>\r";
						$output += "</td></tr>\r\r";
					} else {
						// or just show the blank marker
						$output += "<tr><td colspan=6 class=body>" + $blank_marker + "</td></tr>\r\r";
					}
					
					// more/top buttons after listings
					$output += "<tr><td colspan=6 class=body>" + $button + "</td></tr>\r\r";
					
					// space between sections
					if ($h == 0) {
						if ($one_big_page) { $output += "<tr><td colspan=6><img src=../graphics/spacer.gif height=36 width=1></td></tr>\r\r"; }
					}
					
				}
	
			}

		}
		
	// finish off the table, and we're done
			
		$output += "</table><br>\r\r";
		if (!$section) {
			$output += "<p class=body>&lt;&ndash; <a href=reporter.asp>Months</a></p>\r\r";
		} else {
			$output += "<p class=body>&lt;&ndash; <a href=reporter.asp?month=" + $month + ">Top " + $top_n + "'s</a></p>\r\r";
		}	
		
	
// otherwise, build a menu of all the available data files
	
	} else {
	

	// get a list of all the files in the data directory
	
		$data_files = new Array();

		FSO = Server.CreateObject("Scripting.FileSystemObject");
		$dir = FSO.GetFolder(absolute_path($data_directory, "filesystem"));
		$dir_files = new Enumerator($dir.Files);
		if ($dir_files) {
			$re = /^\d{4}-\d{2}.txt$/;
			for (; !$dir_files.atEnd(); $dir_files.moveNext() ) {
				$file = $dir_files.item().Name;
				if ($re.test($file)) {
					$data_files.push($file);
				}
			}
		} else {
			$output += "<b>Error:</b> Can't read the contents of the data directory " + $data_directory + "<p>\r\r";
		}
		FSO = "";
		
		function sort_descending_files (a,b) {
			// sort the files names numerically
			a = parseInt(a.replace(/[^\d]/g, ""));
			b = parseInt(b.replace(/[^\d]/g, ""));
			return ( (a>b) ? -1 : ( (a<b) ? 1 : 0 ) )	
		}
		$data_files.sort(sort_descending_files);
		$data_files_count = $data_files.length;
					
	
	// make an associative array containing the number of hits in each file
	
		$hits_total = 0;
		for ($i=0; $i < $data_files_count; $i++) {
			$text = get_file_simple($data_directory + $data_files[$i]);
			$text_lines = $text.split("\r");
			$hits = $text_lines.length;
			if ($i == 0) {
				// get the last hit out of the first file, since we've sorted the files from newest to oldest
				$last_line = $text_lines[($hits - 1)].split("\t");
				$last_hit = $last_line[0];
				//$last_file = $data_files[$i]; // debug
			}

			$data_files[$data_files[$i]] = $hits;
			$hits_total = $hits_total + $hits;
			if ($hits > $hits_greatest) { $hits_greatest = $hits; }
		}
		
		
	// print the file names and number of hits in a table
	
		$month_oldest = $data_files[$data_files_count - 1].substring(0, $data_files[$data_files_count - 1].length - 4);

		$output += "<p class=heading>Traffic since " + month_display($month_oldest) + "</p>\r\r";
		
		$output += "<p class=subheading>Last hit: " + $last_hit + "</p>\r";
		$output += "<p class=subheading>Total hits: " + $hits_total + "</p><br>\r\r";
		
		$output += "<table cellpadding=2 cellspacing=0 border=0>\r\r";
		
		$output += "<tr><td colspan=5 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br>Monthly reports</td></tr>\r\r";
		
		for ($i=0; $i < $data_files_count; $i++) {
			$key = $data_files[$i];
			$value = $data_files[$key];
			$month = $key.substr(0, ($key.length - 4));
			$output += "<tr><td class=body>\r";
			$output += "<a href=reporter.asp?month=" + $month + ">" + $month + "</a>\r";  // change the last $month to $key here to show the .txt extensions in the menu
			$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td class=body>\r";
			$output += $value;
			$output += "</td>\n<td align=right><img src=../graphics/spacer.gif width=12 height=1></td>\n<td width=" + $graph_width + ">\r";
			$output += "<font color=" + random_color() + "><img src=../graphics/spacer.gif height=4 width=" + (($value / $hits_greatest) * $graph_width) + " border=1></font>\r";
			$output += "</td></tr>\r";
		}
		
		$output += "<tr><td colspan=5>&nbsp;</td></tr>\r\r";

		$output += "<tr><td colspan=5 bgcolor=#CCCCCC class=subheading><img src=../graphics/spacer.gif height=2 width=1><br>Other views</td></tr>\r\r";

		$output += "<tr><td class=body>\r";	
		$output += "<a href=\"JavaScript:window.open('realtime.swf?script_extension=asp&graph_color="+$graph_color+"&graph_image="+$graph_image+"&update_interval="+$update_interval+"','realtime','width=550,height=500,location=no,menubar=no,directories=no,toolbar=no,scrollbars=yes,resizable=yes,status=yes')\">Real-time display</a><br>\r\r";	
		$output += "<a href=data/>Raw logs</a><br>\r";
		$output += "</td></tr>\r\r";
			
		$output += "</table><br>\r\r";
		
	}
	
	
//  print everything to the browser
	
	Response.write($output);
	

// if requested, show a performance report

	if ($show_performance) {
		$JScript_date = new Date();
		$this_performance_time = $JScript_date.getSeconds();
		$performance_times += "&nbsp;&nbsp;wrap up - " + ($this_performance_time - $last_performance_time) + " seconds <br>\r";
		$total_performance_time = $total_performance_time + ($this_performance_time - $last_performance_time);
		$last_performance_time = $this_performance_time;
	}

	if ($show_performance) {
		Response.write("Language: asp<br>\r");
		Response.write("Host: " + $my_host + "<br>\r");
		Response.write("Total hits:<br>" + $hits_total + "\r");
		Response.write("Performance times:<br>" + $performance_times + "\r");
		Response.write("Total time: " + $total_performance_time + " seconds\r");
	}
	

//  we're done!

	Response.write("</div>\r");

	Response.write("</body></html>\r");

%>